#ifndef DUNE_GEOGRID_STORAGE_HH
#define DUNE_GEOGRID_STORAGE_HH

namespace Dune
{

  namespace GeoGrid
  {

    template< class Object >
    class Storage
    {
      struct MemObject
      {
        Object object;
        MemObject *next;
      };
      
      MemObject *top_;

      Storage ()
      : top_( 0 )
      {}

      Storage ( const Storage & );

      ~Storage ()
      {
        while( top_ != 0 )
        {
          MemObject *ptr = top_;
          top_ = top_->next;
          delete ptr;
        }
      }

      static Storage &instance ()
      {
        static Storage singleton;
        return singleton;
      }

    public:
      static Object *alloc ()
      {
        MemObject *&top = instance().top_;

        MemObject *ptr = top;
        if( ptr != 0 )
          top = ptr->next;
        else
          ptr = new MemObject;
        return &(ptr->object);
      }

      static void free ( Object *object )
      {
        MemObject *&top = instance().top_;

        MemObject *ptr = reinterpret_cast< MemObject * >( object );
        if( ptr != 0 )
        {
          ptr->next = top;
          top = ptr;
        }
      }
    };

  }

}

#endif
