#ifndef DUNE_DGFPARSERS_HH
#define DUNE_DGFPARSERS_HH
#include "dgfparser.hh"
#include <dune/grid/sgrid.hh>
namespace Dune {
template <int dim,int dimworld, class ctype>
class MacroGrid::Impl< SGrid<dim,dimworld,ctype> > 
{
  typedef MPIHelper::MPICommunicator MPICommunicatorType;
public:
  static SGrid<dim,dimworld,ctype>* 
  generate(MacroGrid& mg,
           const char* filename, 
           MPICommunicatorType MPICOMM = MPIHelper::getCommunicator()
          );
};

template <int dim, int dimworld, class ctype>
struct DGFGridInfo< SGrid<dim,dimworld,ctype> > 
{
  static int refineStepsForHalf() { return 1; }
  static double refineWeight() { return pow(0.5,dim); }
};
} // end namespace Dune 
#include "dgfs.cc"
#endif
